import processing.serial.*;

//declaring objects
Serial myPort;
PFont font;
Dial tempDial;
Dial humDial;
Molecules m;

//generating an array of molecules
int numMolecules = 300;
Molecules [] molecules = new Molecules[numMolecules];

//sensor values
int temp = 0;
int hum = 0;


void setup(){
  size(800,400);
   myPort = new Serial(this, "COM3", 9600);
   myPort.bufferUntil('\n');
  
  font = loadFont("HPSimplified-Bold-36.vlw");
  textFont(font);
  tempDial = new Dial(200,200,300,50,"temperature");
  humDial = new Dial(600,200,300,90,"percent humidity");
  
  for(int i=0;i<numMolecules;i++){
    molecules[i] = new Molecules(30);
  }
}

void draw(){
  background(255);
  for(int i=0;i<molecules.length;i++){
    molecules[i].setSensorValue(temp,hum);
    molecules[i].display();
    molecules[i].move();
   }
   tempDial.displayDial();
   tempDial.setSensorValue(temp);
   humDial.displayDial();
   humDial.setSensorValue(hum);
}

void serialEvent(Serial myPort){
  //read the serial buffer
  String myString = myPort.readStringUntil('\n');
  if(myString != null){
    myString = trim(myString);
    int sensorData[] = int(split(myString,','));
    temp = sensorData[0];
    hum = sensorData[1];
  }
}